# 6. 시험(Testing)

## 6.1 유닛 테스트(Unit test)

유닛 테스트로 69.6%의 Line Coverage와 73.4%의 Function Coverage를 달성했다.
다음과 같은 로그가 있다.

```
running 2 tests from ./src/auth/permission.test.ts
permission.test ... ok (8ms)
permission empty ... ok (16ms)
running 4 tests from ./src/auth/session.test.ts
Session ...
  set ... ok (9ms)
  delete ... ok (16ms)
ok (42ms)
Login Handler ...
  login with invalid format ... ok (15ms)
  login with invalid password ... ok (16ms)
  login ... ok (16ms)
  logout with no session ... ok (16ms)
  logout ... ok (16ms)
ok (96ms)
getSession ... ok (16ms)
getSession with invalid cookie ... ok (16ms)
running 1 test from ./src/auth/user.test.ts
user.createAdminUser ... ok (15ms)
running 4 tests from ./src/document/filedoc.test.ts
readDocFile ... ok (19ms)
readDocFile: not found ... ok (16ms)
readDocFile: invalid json ... ok (16ms)
saveDocFile ... ok (15ms)
running 3 tests from ./src/router/methodHandle.test.ts
methodHandle: basic methods ... ok (8ms)
methodHandle: not found ... ok (16ms)
methodHandle: options ... ok (16ms)
running 8 tests from ./src/router/route.test.ts
route: basic route ... ok (10ms)
route: double slash route ... ok (16ms)
route: double match ... ok (16ms)
route: test context ... ok (16ms)
route: test regex ... ok (16ms)
route: test not found ... ok (16ms)
route: encode_route ... ok (2ms)
route: router in router ... ok (13ms)
running 4 tests from ./src/rpc/chunk.test.ts
basic chunk operation ...
  create chunk ... ok (19ms)
  delete chunk ... ok (15ms)
  modify chunk ... ok (15ms)
  move chunk ... ok (15ms)
  invalid chunk operation ... ok (17ms)
ok (98ms)
test chunk notification operation ... ok (15ms)
test chunk conflict ... ok (16ms)
test chunk conflict resolve with history ... ok (32ms)
running 2 tests from ./src/rpc/doc.test.ts
handleDocumentMethod ... ok (4ms)
handleTagMethod ...
  setTag ... ok (13ms)
  getTag ... ok (15ms)
  conflict ... ok (15ms)
ok (61ms)
running 3 tests from ./src/rpc/share.test.ts
handleShareGetInfo ... ok (18ms)
handleShareDocMethod ... ok (15ms)
handleShareMethod with no existing share token ... ok (16ms)
running 1 test from ./src/server.test.ts
server rpc test ... ok (1s)
running 3 tests from ./src/setting.test.ts
setting: basic ... ok (35ms)
setting: default value ... ok (7ms)
setting: defered register ... ok (16ms)
test result: ok. 35 passed (15 steps); 0 failed; 0 ignored; 0 measured; 0 filtered out (2s)
```

## 6.2 기능 테스트(Functional Test)

<% const keys = Array.from(it.table.keys()); %>

<% keys.forEach(c=>{ 
  const issues = it.table.get(c);
  const ts = issues.map(x=> it.testcases.filter(y=>y.id==x.number)).flat();
  if(ts?.length == 0) return; %>
<%~`\n\n### ${c}\n\n`%>
<%~"<table>"%>
<%~"<thead>"%>
<%~"<tr>"%>
<%~"<th>ID</th>"%>
<%~"<th>Content</th>"%>
<%~"<th>Procedure</th>"%>
<%~"<th>Test Data</th>"%>
<%~"<th>P/F</th>"%>
<%~"</tr>"%>
<%~"</thead>"%>
<%~"<tbody>"%>
<% ts.forEach((y,i)=>{
      const id = y.subId ? `${y.id}-${y.subId}` : y.id;%>
<%~"<tr>"%>
<%~`<td>${id}</td>`%>
<%~`<td>${y.content}</td>`%>
<%~`<td>${y.procedure}</td>`%>
<%~`<td>${y.testData ?? ""}</td>`%>
<%~`<td>${y.pass ? "P" : "F"}</td>`%>
<%~"</tr>"%>
<%});%>
<%~"</tbody>"%>
<%~"</table>"%>
<% });%>